/*
 * The MIT License

   BLDConograph (Bravais lattice determination module in Conograph)

Copyright (c) <2012> <Ryoko Oishi-Tomiyasu, KEK>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 *
 */
#ifndef COMMON_HH_
#define COMMON_HH_

#include<vector>
#include<complex>

using namespace std;

typedef char Char;
typedef unsigned char UChar;
typedef short Int2;
typedef unsigned short UInt2;
typedef int Int4;
typedef unsigned int UInt4;
typedef long long Int8;
//typedef unsigned long long UInt8;	//Mac OS X define UInt8 (typedef unsigned char)
typedef double Double;
typedef float Float;

#ifdef __x86_64__
	typedef Int8 ArrayIndex;
#else
	typedef Int4 ArrayIndex;
#endif

typedef vector<double> Vec_DP;
typedef vector<int> Vec_INT;
typedef vector<char> Vec_CHAR;
typedef vector<bool> Vec_BOOL;
//typedef vector< vector<int> > Mat_INT_iconstr;
typedef vector< vector<double> > Mat_DP_iconstr;

typedef complex<double> CMPX_DP;

typedef vector< vector<double> > each_Vec_DP;
typedef vector< vector<Int4> > each_Vec_INT;

#endif /*COMMON_HH_*/
